<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
<title>19 Lecture 10 - 2019 | Learning bayesian data analysis with Statistical Rethinking</title>
<meta name="author" content="Alec L. Robitaille">
<meta name="description" content="19.1 Markov Chain Monte Carlo Reminder: Bayesian inference is about calculating the posterior. Bayesian ≠ Markov Chains 4 of the ways to compute the posterior Analytical approach (mostly...">
<meta name="generator" content="bookdown 0.24.1 with bs4_book()">
<meta property="og:title" content="19 Lecture 10 - 2019 | Learning bayesian data analysis with Statistical Rethinking">
<meta property="og:type" content="book">
<meta property="og:url" content="https://www.statistical-rethinking.robitalec.ca/lecture-10---2019.html">
<meta property="og:description" content="19.1 Markov Chain Monte Carlo Reminder: Bayesian inference is about calculating the posterior. Bayesian ≠ Markov Chains 4 of the ways to compute the posterior Analytical approach (mostly...">
<meta name="twitter:card" content="summary">
<meta name="twitter:title" content="19 Lecture 10 - 2019 | Learning bayesian data analysis with Statistical Rethinking">
<meta name="twitter:description" content="19.1 Markov Chain Monte Carlo Reminder: Bayesian inference is about calculating the posterior. Bayesian ≠ Markov Chains 4 of the ways to compute the posterior Analytical approach (mostly...">
<!-- JS --><script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/2.0.6/clipboard.min.js" integrity="sha256-inc5kl9MA1hkeYUt+EC3BhlIgyp/2jDIyBLS6k3UxPI=" crossorigin="anonymous"></script><script src="https://cdnjs.cloudflare.com/ajax/libs/fuse.js/6.4.6/fuse.js" integrity="sha512-zv6Ywkjyktsohkbp9bb45V6tEMoWhzFzXis+LrMehmJZZSys19Yxf1dopHx7WzIKxr5tK2dVcYmaCk2uqdjF4A==" crossorigin="anonymous"></script><script src="https://kit.fontawesome.com/6ecbd6c532.js" crossorigin="anonymous"></script><script src="libs/header-attrs-2.11.3/header-attrs.js"></script><script src="libs/jquery-3.6.0/jquery-3.6.0.min.js"></script><meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
<link href="libs/bootstrap-4.6.0/bootstrap.min.css" rel="stylesheet">
<script src="libs/bootstrap-4.6.0/bootstrap.bundle.min.js"></script><script src="libs/bs3compat-0.3.1/transition.js"></script><script src="libs/bs3compat-0.3.1/tabs.js"></script><script src="libs/bs3compat-0.3.1/bs3compat.js"></script><link href="libs/bs4_book-1.0.0/bs4_book.css" rel="stylesheet">
<script src="libs/bs4_book-1.0.0/bs4_book.js"></script><script src="https://cdnjs.cloudflare.com/ajax/libs/autocomplete.js/0.38.0/autocomplete.jquery.min.js" integrity="sha512-GU9ayf+66Xx2TmpxqJpliWbT5PiGYxpaG8rfnBEk1LL8l1KGkRShhngwdXK1UgqhAzWpZHSiYPc09/NwDQIGyg==" crossorigin="anonymous"></script><script src="https://cdnjs.cloudflare.com/ajax/libs/mark.js/8.11.1/mark.min.js" integrity="sha512-5CYOlHXGh6QpOFA/TeTylKLWfB3ftPsde7AnmhuitiTX4K5SqCLBeKro6sPS8ilsz1Q4NRx3v8Ko2IBiszzdww==" crossorigin="anonymous"></script><!-- CSS --><link rel="stylesheet" href="style.css">
</head>
<body data-spy="scroll" data-target="#toc">

<div class="container-fluid">
<div class="row">
  <header class="col-sm-12 col-lg-3 sidebar sidebar-book"><a class="sr-only sr-only-focusable" href="#content">Skip to main content</a>

    <div class="d-flex align-items-start justify-content-between">
      <h1>
        <a href="index.html" title="">Learning bayesian data analysis with Statistical Rethinking</a>
      </h1>
      <button class="btn btn-outline-primary d-lg-none ml-2 mt-1" type="button" data-toggle="collapse" data-target="#main-nav" aria-expanded="true" aria-controls="main-nav"><i class="fas fa-bars"></i><span class="sr-only">Show table of contents</span></button>
    </div>

    <div id="main-nav" class="collapse-lg">
      <form role="search">
        <input id="search" class="form-control" type="search" placeholder="Search" aria-label="Search">
</form>

      <nav aria-label="Table of contents"><h2>Table of contents</h2>
        <ul class="book-toc list-unstyled">
<li><a class="" href="index.html">Overview</a></li>
<li class="book-part">Homework</li>
<li><a class="" href="week-1.html"><span class="header-section-number">1</span> Week 1</a></li>
<li><a class="" href="week-2.html"><span class="header-section-number">2</span> Week 2</a></li>
<li><a class="" href="week-3.html"><span class="header-section-number">3</span> Week 3</a></li>
<li><a class="" href="week-4.html"><span class="header-section-number">4</span> Week 4</a></li>
<li><a class="" href="week-5.html"><span class="header-section-number">5</span> Week 5</a></li>
<li><a class="" href="week-6.html"><span class="header-section-number">6</span> Week 6</a></li>
<li><a class="" href="week-7.html"><span class="header-section-number">7</span> Week 7</a></li>
<li><a class="" href="week-8.html"><span class="header-section-number">8</span> Week 8</a></li>
<li><a class="" href="week-9.html"><span class="header-section-number">9</span> Week 9</a></li>
<li class="book-part">Lectures 2019</li>
<li><a class="" href="lecture-01---2019.html"><span class="header-section-number">10</span> Lecture 01 - 2019</a></li>
<li><a class="" href="lecture-02---2019.html"><span class="header-section-number">11</span> Lecture 02 - 2019</a></li>
<li><a class="" href="lecture-03---2019.html"><span class="header-section-number">12</span> Lecture 03 - 2019</a></li>
<li><a class="" href="lecture-04---2019.html"><span class="header-section-number">13</span> Lecture 04 - 2019</a></li>
<li><a class="" href="lecture-05---2019.html"><span class="header-section-number">14</span> Lecture 05 - 2019</a></li>
<li><a class="" href="lecture-06---2019.html"><span class="header-section-number">15</span> Lecture 06 - 2019</a></li>
<li><a class="" href="lecture-07---2019.html"><span class="header-section-number">16</span> Lecture 07 - 2019</a></li>
<li><a class="" href="lecture-08---2019.html"><span class="header-section-number">17</span> Lecture 08 - 2019</a></li>
<li><a class="" href="lecture-09---2019.html"><span class="header-section-number">18</span> Lecture 09 - 2019</a></li>
<li><a class="active" href="lecture-10---2019.html"><span class="header-section-number">19</span> Lecture 10 - 2019</a></li>
<li><a class="" href="lecture-11---2019.html"><span class="header-section-number">20</span> Lecture 11 - 2019</a></li>
<li><a class="" href="lecture-12---2019.html"><span class="header-section-number">21</span> Lecture 12 - 2019</a></li>
<li><a class="" href="lecture-13---2019.html"><span class="header-section-number">22</span> Lecture 13 - 2019</a></li>
<li><a class="" href="lecture-14---2019.html"><span class="header-section-number">23</span> Lecture 14 - 2019</a></li>
<li><a class="" href="lecture-15---2019.html"><span class="header-section-number">24</span> Lecture 15 - 2019</a></li>
<li><a class="" href="lecture-16---2019.html"><span class="header-section-number">25</span> Lecture 16 - 2019</a></li>
<li><a class="" href="lecture-17---2019.html"><span class="header-section-number">26</span> Lecture 17 - 2019</a></li>
<li><a class="" href="lecture-18---2019.html"><span class="header-section-number">27</span> Lecture 18 - 2019</a></li>
<li><a class="" href="lecture-19---2019.html"><span class="header-section-number">28</span> Lecture 19 - 2019</a></li>
<li><a class="" href="lecture-20---2019.html"><span class="header-section-number">29</span> Lecture 20 - 2019</a></li>
<li class="book-part">Lectures 2022</li>
<li><a class="" href="lecture-01---2022.html"><span class="header-section-number">30</span> Lecture 01 - 2022</a></li>
<li><a class="" href="lecture-02---2022.html"><span class="header-section-number">31</span> Lecture 02 - 2022</a></li>
<li class="book-part">References</li>
<li><a class="" href="references.html"><span class="header-section-number">32</span> References</a></li>
</ul>

        <div class="book-extra">
          <p><a id="book-repo" href="https://gitlab.com/robitalec/statistical-rethinking">View book source <i class="fab fa-gitlab"></i></a></p>
        </div>
      </nav>
</div>
  </header><main class="col-sm-12 col-md-9 col-lg-7" id="content"><div id="lecture-10---2019" class="section level1" number="19">
<h1>
<span class="header-section-number">19</span> Lecture 10 - 2019<a class="anchor" aria-label="anchor" href="#lecture-10---2019"><i class="fas fa-link"></i></a>
</h1>
<div id="markov-chain-monte-carlo" class="section level2" number="19.1">
<h2>
<span class="header-section-number">19.1</span> Markov Chain Monte Carlo<a class="anchor" aria-label="anchor" href="#markov-chain-monte-carlo"><i class="fas fa-link"></i></a>
</h2>
<p>Reminder: Bayesian inference is about calculating the posterior. Bayesian ≠ Markov Chains</p>
<p>4 of the ways to compute the posterior</p>
<ol style="list-style-type: decimal">
<li>Analytical approach (mostly impossible)</li>
<li>Grid approximation (very intensive)</li>
<li>Quadratic approximate (limited)</li>
<li>MCMC (intensive)</li>
</ol>
<p>Advantages of MCMC</p>
<ul>
<li>You don’t know the posterior yet you can still visit each part of it in proportion to it’s relative probability</li>
<li>“Sample from a distribution that we don’t know”</li>
</ul>
<div id="metropolis-algorithm" class="section level3" number="19.1.1">
<h3>
<span class="header-section-number">19.1.1</span> Metropolis algorithm<a class="anchor" aria-label="anchor" href="#metropolis-algorithm"><i class="fas fa-link"></i></a>
</h3>
<ol style="list-style-type: decimal">
<li>Loop over iterations</li>
<li>Record location</li>
<li>Generate neighbor location proposals</li>
<li>Move based on frequency</li>
</ol>
<p>Converges in the long run, can be used as long as proposals are symmetric</p>
</div>
<div id="metropolis-hastings" class="section level3" number="19.1.2">
<h3>
<span class="header-section-number">19.1.2</span> Metropolis Hastings<a class="anchor" aria-label="anchor" href="#metropolis-hastings"><i class="fas fa-link"></i></a>
</h3>
<p>Improvement on Metropolis, does not require the proposals to be symmetrical</p>
</div>
<div id="gibbs-sampling" class="section level3" number="19.1.3">
<h3>
<span class="header-section-number">19.1.3</span> Gibbs sampling<a class="anchor" aria-label="anchor" href="#gibbs-sampling"><i class="fas fa-link"></i></a>
</h3>
<p>More efficient version of MH</p>
</div>
<div id="hamiltonian-monte-carlo" class="section level3" number="19.1.4">
<h3>
<span class="header-section-number">19.1.4</span> Hamiltonian Monte Carlo<a class="anchor" aria-label="anchor" href="#hamiltonian-monte-carlo"><i class="fas fa-link"></i></a>
</h3>
<p>Markov Chain: No memory. Probability solely depends on current state, not past state. No storage.</p>
<p>Monte Carlo: Random simulation (eg Monaco casino)</p>
<p>MCMC is a numerical technique to solve for the posterior, with several advantages over Metropolis and Gibbs</p>
<ul>
<li>Metropolis and Gibbs use optimization but optimization is not a good strategy in high dimensions (see concentration of measure)</li>
<li>Hamiltonian Monte Carlo uses a gradient to avoid the guess + check of Metropolis and Gibbs</li>
<li>Especially in high dimensional space, acceptance rate decreases and methods take more time</li>
</ul>
<p>Hamiltonian Monte Carlo:</p>
<ol style="list-style-type: decimal">
<li>Uses a physics simulation representing the parameter state as a particle</li>
<li>Flicks the particle around a friction less log-posterior surface</li>
<li>Follows curvature of the surface, so it doesn’t get stuck</li>
<li>Uses random direction and random speed</li>
<li>Slows as it climbs, speeds as it drops</li>
</ol>
<p>This is much more computationally intensive, but requires less steps, has much fewer rejections</p>
<p>It’s also easier to determine if MCMC has failed</p>
</div>
<div id="tuning-mcmc" class="section level3" number="19.1.5">
<h3>
<span class="header-section-number">19.1.5</span> Tuning MCMC<a class="anchor" aria-label="anchor" href="#tuning-mcmc"><i class="fas fa-link"></i></a>
</h3>
<p>Step size: time the simulation is run. Increase step size = increase efficiency but overestimates curvature</p>
<p>U Turn risk is solved by NUTS (No U Turn Sampler)</p>
<ol style="list-style-type: decimal">
<li>Warm up phase - finding the step size to maximize acceptance rate. Default = good (half the number of samples)</li>
<li>Runs in both directions and gives uncorrelated samples. No need to pick leap frog steps</li>
</ol>
</div>
<div id="stan" class="section level3" number="19.1.6">
<h3>
<span class="header-section-number">19.1.6</span> Stan<a class="anchor" aria-label="anchor" href="#stan"><i class="fas fa-link"></i></a>
</h3>
<p>Stan uses NUTS</p>
</div>
<div id="ulam" class="section level3" number="19.1.7">
<h3>
<span class="header-section-number">19.1.7</span> ulam<a class="anchor" aria-label="anchor" href="#ulam"><i class="fas fa-link"></i></a>
</h3>
<ol style="list-style-type: decimal">
<li>Create list of data only what you need</li>
<li>
<code>ulam</code> with formulas as in <code>quap</code>
</li>
<li>
<code>ulam</code> translates the formulas to Stan</li>
<li>Builds the NUTS sampler</li>
<li>Sampler runs</li>
<li>Returns posterior</li>
</ol>
</div>
<div id="diagnosis" class="section level3" number="19.1.8">
<h3>
<span class="header-section-number">19.1.8</span> Diagnosis<a class="anchor" aria-label="anchor" href="#diagnosis"><i class="fas fa-link"></i></a>
</h3>
<p>Neff: number of effective samples. Can be greater than the number of samples from the Markov Chan. Effective if no autocorrelation</p>
<p>Rhat: Convergence diagnostic. 1 is good. Ratio of variance within vs ratio of variance across chains.</p>
<p>“<strong>Typically when you have a computational problem, often there’s a problem with your model”</strong></p>
</div>
<div id="checking-the-chain" class="section level3" number="19.1.9">
<h3>
<span class="header-section-number">19.1.9</span> Checking the chain<a class="anchor" aria-label="anchor" href="#checking-the-chain"><i class="fas fa-link"></i></a>
</h3>
<p>TODO: p283</p>
</div>
</div>
</div>
  <div class="chapter-nav">
<div class="prev"><a href="lecture-09---2019.html"><span class="header-section-number">18</span> Lecture 09 - 2019</a></div>
<div class="next"><a href="lecture-11---2019.html"><span class="header-section-number">20</span> Lecture 11 - 2019</a></div>
</div></main><div class="col-md-3 col-lg-2 d-none d-md-block sidebar sidebar-chapter">
    <nav id="toc" data-toggle="toc" aria-label="On this page"><h2>On this page</h2>
      <ul class="nav navbar-nav">
<li><a class="nav-link" href="#lecture-10---2019"><span class="header-section-number">19</span> Lecture 10 - 2019</a></li>
<li>
<a class="nav-link" href="#markov-chain-monte-carlo"><span class="header-section-number">19.1</span> Markov Chain Monte Carlo</a><ul class="nav navbar-nav">
<li><a class="nav-link" href="#metropolis-algorithm"><span class="header-section-number">19.1.1</span> Metropolis algorithm</a></li>
<li><a class="nav-link" href="#metropolis-hastings"><span class="header-section-number">19.1.2</span> Metropolis Hastings</a></li>
<li><a class="nav-link" href="#gibbs-sampling"><span class="header-section-number">19.1.3</span> Gibbs sampling</a></li>
<li><a class="nav-link" href="#hamiltonian-monte-carlo"><span class="header-section-number">19.1.4</span> Hamiltonian Monte Carlo</a></li>
<li><a class="nav-link" href="#tuning-mcmc"><span class="header-section-number">19.1.5</span> Tuning MCMC</a></li>
<li><a class="nav-link" href="#stan"><span class="header-section-number">19.1.6</span> Stan</a></li>
<li><a class="nav-link" href="#ulam"><span class="header-section-number">19.1.7</span> ulam</a></li>
<li><a class="nav-link" href="#diagnosis"><span class="header-section-number">19.1.8</span> Diagnosis</a></li>
<li><a class="nav-link" href="#checking-the-chain"><span class="header-section-number">19.1.9</span> Checking the chain</a></li>
</ul>
</li>
</ul>

      <div class="book-extra">
        <ul class="list-unstyled">
<li><a id="book-source" href="https://gitlab.com/robitalec/statistical-rethinking/blob/master/notes/notes-2019.Rmd">View source <i class="fab fa-gitlab"></i></a></li>
          <li><a id="book-edit" href="https://gitlab.com/robitalec/statistical-rethinking/edit/master/notes/notes-2019.Rmd">Edit this page <i class="fab fa-gitlab"></i></a></li>
        </ul>
</div>
    </nav>
</div>

</div>
</div> <!-- .container -->

<footer class="bg-primary text-light mt-5"><div class="container"><div class="row">

  <div class="col-12 col-md-6 mt-3">
    <p>"<strong>Learning bayesian data analysis with Statistical Rethinking</strong>" was written by Alec L. Robitaille. It was last built on 2022-01-26 [started: 2021-08-18].</p>
  </div>

  <div class="col-12 col-md-6 mt-3">
    <p>This book was built by the <a class="text-light" href="https://bookdown.org">bookdown</a> R package.</p>
  </div>

</div></div>
</footer><!-- dynamically load mathjax for compatibility with self-contained --><script>
  (function () {
    var script = document.createElement("script");
    script.type = "text/javascript";
    var src = "true";
    if (src === "" || src === "true") src = "https://mathjax.rstudio.com/latest/MathJax.js?config=TeX-MML-AM_CHTML";
    if (location.protocol !== "file:")
      if (/^https?:/.test(src))
        src = src.replace(/^https?:/, '');
    script.src = src;
    document.getElementsByTagName("head")[0].appendChild(script);
  })();
</script><script type="text/x-mathjax-config">const popovers = document.querySelectorAll('a.footnote-ref[data-toggle="popover"]');
for (let popover of popovers) {
  const div = document.createElement('div');
  div.setAttribute('style', 'position: absolute; top: 0, left:0; width:0, height:0, overflow: hidden; visibility: hidden;');
  div.innerHTML = popover.getAttribute('data-content');

  var has_math = div.querySelector("span.math");
  if (has_math) {
    document.body.appendChild(div);
    MathJax.Hub.Queue(["Typeset", MathJax.Hub, div]);
    MathJax.Hub.Queue(function() {
      popover.setAttribute('data-content', div.innerHTML);
      document.body.removeChild(div);
    })
  }
}
</script>
</body>
</html>
